﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace proba
{
    enum RowState
    { 
        Existed,
        New,
        ModifiedNew,
        Deleted
    }
    public partial class Country : Form
    {
        string id_country;
        string country;
        bool save;
        DataBase dataBase = new DataBase();
        public Country()
        {
            InitializeComponent();
        }
        private void CreateColumns()
        {
            dataGridView1.Columns.Add("country", "Название страны");
            dataGridView1.Columns.Add("", String.Empty);
        }
        private void ReadSingleRow(DataGridView dgw, IDataRecord record)
        {
            dgw.Rows.Add(record.GetString(0), RowState.ModifiedNew);
        }
        private void RefresDataGird(DataGridView dgw)
        {
            dgw.Rows.Clear();
            dataGridView1.Columns[1].Visible = false;
            string queryString = $"Select country from Country";
            SqlCommand command = new SqlCommand(queryString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader reader = command.ExecuteReader();
            while (reader.Read())
            {
                ReadSingleRow(dgw, reader);
            }
            reader.Close();
        }
        private void button_add_Click(object sender, EventArgs e)
        {
            this.Hide();
            CountryAdd country_Add = new CountryAdd();
            country_Add.ShowDialog();
        }
        private void Country_Load(object sender, EventArgs e)
        {
            CreateColumns();
            RefresDataGird(dataGridView1);
        }
        private void button_back_Click(object sender, EventArgs e)
        {
            MainMenu f1 = new MainMenu();
            f1.Show();
            Hide();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void button_insert_Click(object sender, EventArgs e)
        {
            if (id_country == null)
            {
                MessageBox.Show("Не выделена строчка для изменения");
            }
            else
            {
                this.Hide();
                CountryUpd countryupd = new CountryUpd(id_country, country);
                countryupd.ShowDialog();
            }
        }
        private void button_delete_Click(object sender, EventArgs e)
        {
            dataBase.openConnection();
            string admin = $"SELECT P.id_product From Country C inner join Products P ON C.id_country = P.id_country WHERE C.country = '{country}'";
            SqlDataAdapter sda = new SqlDataAdapter(admin, dataBase.GetConnection());
            DataTable dtbl = new DataTable();
            sda.Fill(dtbl);
            if (dtbl.Rows.Count < 1)
            {
                if (id_country == null)
                {
                    MessageBox.Show("Не выделена запись для удаления!!!");
                }
                else
                {
                    deleteRow();
                    save = true;
                }
            }
            else
            {
                MessageBox.Show("Нельзя удалить запись, на которую есть ссылка!!!");
            }
            dataBase.closeConnection();
        }
        private void deleteRow()
        {
            int index = dataGridView1.CurrentCell.RowIndex;
            dataGridView1.Rows[index].Visible = false;
            if (dataGridView1.Rows[index].Cells[0].Value.ToString() == String.Empty)
            {
                dataGridView1.Rows[index].Cells[1].Value = RowState.Deleted;
                return;
            }
            dataGridView1.Rows[index].Cells[1].Value = RowState.Deleted;
            id_country = null;
        }
        new private void Update()
        {
            dataBase.openConnection();
            for (int index = 0; index < dataGridView1.Rows.Count; index++)
            {
                var rowState = (RowState)dataGridView1.Rows[index].Cells[1].Value;
                if (rowState == RowState.Existed)
                    continue;
                if (rowState == RowState.Deleted)
                {
                    SqlCommand sqlCommand_country = new SqlCommand($"SELECT id_country From Country WHERE country = '{dataGridView1.Rows[index].Cells[0].Value}'", dataBase.GetConnection());
                    var id = sqlCommand_country.ExecuteScalar().ToString();
                    var deleteQuery = $"delete from Country where id_country = {id}";
                    var command = new SqlCommand(deleteQuery, dataBase.GetConnection());
                    command.ExecuteNonQuery();
                }
            }
            dataBase.closeConnection();
        }
        private void StrokaSearch_TextChanged(object sender, EventArgs e)
        {
            Search(dataGridView1);
        }
        private void Search(DataGridView dgw)
        {
            dgw.Rows.Clear();
            string searchString = $"Select country from Country Where country like '%" + StrokaSearch.Text + "%'";
            SqlCommand com = new SqlCommand(searchString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader read = com.ExecuteReader();
            while (read.Read())
            {
                ReadSingleRow(dgw, read);
            }
            read.Close();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (save == true)
            {
                Update();
                save = false;
            }
        }
        private void dataGridView1_CellClick_1(object sender, DataGridViewCellEventArgs e)
        {
            var selectedRow = e.RowIndex;
            if (e.RowIndex >= 0)
            {
                DataGridViewRow row = dataGridView1.Rows[selectedRow];
                country = row.Cells[0].Value.ToString();
                SqlCommand sqlCommand_country = new SqlCommand($"SELECT id_country From Country WHERE country = '{country}'", dataBase.GetConnection());
                id_country = sqlCommand_country.ExecuteScalar().ToString();
            }
        }
        private void pictureBox1_Click(object sender, EventArgs e)
        {
            RefresDataGird(dataGridView1);
            save = false;
        }
    }
}

