﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Data.SqlClient;

namespace proba
{
    public partial class Nomenklatura : Form
    {
        string id_product;
        string product;
        string description;
        string price;
        string year_publishing;
        string country;
        string edition;
        string genre;
        string performer;
        string supplier;
        bool save;
        DataBase dataBase = new DataBase();
        public Nomenklatura()
        {
            InitializeComponent();
        }
        private void CreateColumns()
        {
            dataGridView1.Columns.Add("product", "Номенклатура");
            dataGridView1.Columns.Add("description", "Описание");
            dataGridView1.Columns.Add("price", "Цена");
            dataGridView1.Columns.Add("year_publishing", "Год издания");
            dataGridView1.Columns.Add("country", "Страна производства");
            dataGridView1.Columns.Add("edition", "Издательство");
            dataGridView1.Columns.Add("genre", "Жанр музыки");
            dataGridView1.Columns.Add("performer", "Исполнитель");
            dataGridView1.Columns.Add("supplier", "Поставщик");
            dataGridView1.Columns.Add("", String.Empty);
        }
        private void ReadSingleRow(DataGridView dgw, IDataRecord record)
        {
            dgw.Rows.Add(record.GetString(0), record.GetString(1), record.GetDouble(2), record.GetString(3), record.GetString(4), record.GetString(5), record.GetString(6), record.GetString(7), record.GetString(8), RowState.ModifiedNew);
        }
        private void RefresDataGird(DataGridView dgw)
        {
            dgw.Rows.Clear();
            dataGridView1.Columns[9].Visible = false;
            string queryString = $"Select P.product, P.description, P.price, P.year_publishing, C.country, E.edition, G.genre, Per.performer, S.name_organization From Products P inner join Country C ON P.id_country = C.id_country inner join Edition E ON P.id_edition = E.id_edition inner join Genre G ON P.id_genre = G.id_genre inner join Performer Per ON P.id_performer = Per.id_performer inner join Supplier S ON P.id_supplier = S.id_supplier";
            SqlCommand command = new SqlCommand(queryString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader reader = command.ExecuteReader();
            while (reader.Read())
            {
                ReadSingleRow(dgw, reader);
            }
            reader.Close();
        }
        private void Nomenklatura_Load(object sender, EventArgs e)
        {
            CreateColumns();
            RefresDataGird(dataGridView1);

        }
        private void button_back_Click(object sender, EventArgs e)
        {
            this.Hide();
            MainMenu mainMenu = new MainMenu();
            mainMenu.ShowDialog();
        }
        public void global_FormClosed(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void pictureBox2_Click(object sender, EventArgs e)
        {
            RefresDataGird(dataGridView1);
            save = false;
        }
        private void button_add_Click(object sender, EventArgs e)
        {
            this.Hide();
            Nomenklaturaadd nomenklatura_Add = new Nomenklaturaadd();
            nomenklatura_Add.ShowDialog();
        }
        private void Search(DataGridView dgw)
        {
            dgw.Rows.Clear();
            string searchString = $"Select P.product, P.description, P.price, P.year_publishing, C.country, E.edition, G.genre, Per.performer, S.name_organization From Products P inner join Country C ON P.id_country = C.id_country inner join Edition E ON P.id_edition = E.id_edition inner join Genre G ON P.id_genre = G.id_genre inner join Performer Per ON P.id_performer = Per.id_performer inner join Supplier S ON P.id_supplier = S.id_supplier Where product like '%" + StrokaSearch.Text +"%'";
            SqlCommand com = new SqlCommand(searchString, dataBase.GetConnection());
            dataBase.openConnection();
            SqlDataReader read = com.ExecuteReader();
            while (read.Read())
            {
                ReadSingleRow(dgw, read);
            }
            read.Close();
        }
        private void deleteRow()
        {
            int index = dataGridView1.CurrentCell.RowIndex;
            dataGridView1.Rows[index].Visible = false;
            if(dataGridView1.Rows[index].Cells[0].Value.ToString() == String.Empty)
            {
                dataGridView1.Rows[index].Cells[9].Value = RowState.Deleted;
                return;
            }
            dataGridView1.Rows[index].Cells[9].Value = RowState.Deleted;
            id_product = null;
        }
        new private void Update()
        {
            dataBase.openConnection();
            for(int index = 0; index < dataGridView1.Rows.Count; index++)
            {
                var rowState = (RowState)dataGridView1.Rows[index].Cells[9].Value;
                if (rowState == RowState.Existed)
                    continue;
                if(rowState == RowState.Deleted)
                {
                    SqlCommand sqlCommand_product = new SqlCommand($"SELECT id_product From Products WHERE product = '{dataGridView1.Rows[index].Cells[0].Value}'", dataBase.GetConnection());
                    var id = sqlCommand_product.ExecuteScalar().ToString();
                    var deleteQuery = $"delete from Products where id_product = {id}";
                    var command = new SqlCommand(deleteQuery, dataBase.GetConnection());
                    command.ExecuteNonQuery();
                }
            }
            dataBase.closeConnection();
        }
        private void StrokaSearch_TextChanged(object sender, EventArgs e)
        {
            Search(dataGridView1);
        }

        private void button_delete_Click(object sender, EventArgs e)
        {
            dataBase.openConnection();
            string admin = $"SELECT S.id_sale From Sales S inner join Products P ON S.id_product = P.id_product WHERE P.product = '{product}'";
            SqlDataAdapter sda = new SqlDataAdapter(admin, dataBase.GetConnection());
            DataTable dtbl = new DataTable();
            sda.Fill(dtbl);
            if (dtbl.Rows.Count < 1)
            {
                if(id_product == null)
            {
                    MessageBox.Show("Не выделена запись для удаления!!!");
                }
            else
                {
                    deleteRow();
                    save = true;
                }
            }
            else
            {
                MessageBox.Show("Нельзя удалить запись, на которую есть ссылка!!!");
            }
            dataBase.closeConnection();
        }
        private void buttonSave_Click(object sender, EventArgs e)
        {
            if (save == true)
            {
                Update();
                save = false;
            }
        }
        private void button_insert_Click(object sender, EventArgs e)
        {
            if(id_product == null)
            {
                MessageBox.Show("Не выделена строчка для изменения");
            }
            else
            {
                this.Hide();
                Nomenklaturaupdate nomenklatura_Update = new Nomenklaturaupdate(id_product, product, description, price, year_publishing, country, edition, genre, performer, supplier);
                nomenklatura_Update.ShowDialog();
            }
        }
        public void dataGridView1_CellClick(object sender, DataGridViewCellEventArgs e)
        {
            var selectedRow = e.RowIndex;
            if (e.RowIndex >= 0)
            {
                DataGridViewRow row = dataGridView1.Rows[selectedRow];
                dataBase.openConnection();
                product = row.Cells[0].Value.ToString();
                description = row.Cells[1].Value.ToString();
                price = row.Cells[2].Value.ToString();
                year_publishing = row.Cells[3].Value.ToString();
                country = row.Cells[4].Value.ToString();
                edition = row.Cells[5].Value.ToString();
                genre = row.Cells[6].Value.ToString();
                performer = row.Cells[7].Value.ToString();
                supplier = row.Cells[8].Value.ToString();
                SqlCommand sqlCommand_product = new SqlCommand($"SELECT id_product From Products WHERE product = '{product}'", dataBase.GetConnection());
                id_product = sqlCommand_product.ExecuteScalar().ToString();
                dataBase.closeConnection();
            }
        }
    }
}
